#include "CenterMsgBox.h"

/*================================================================================================*/
static HHOOK f_hHook;
static HWND f_hWndParent;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
static LRESULT CALLBACK CBTHookProc
    (
    int nCode,                      /*  ,   HCBT_ACTIVATE */
    WPARAM wParam,                  /*    (MessageBox') */
    LPARAM lParam                   /*   CBTACTIVATESTRUCT */
    )                               /*  0 ( ) */
    {
    bool unhook = false;
    LRESULT result;
    HWND hParent;
    RECT ParentRect, ChildRect, ScreenRect;
    LONG x, y, width, height;
    switch (nCode)
        {
        case HCBT_ACTIVATE:
            if (!wParam || !lParam) break;
            // hParent = GetAncestor(((LPCBTACTIVATESTRUCT)lParam)->hWndActive, GA_ROOT);
            hParent = f_hWndParent;
            /*   ,    */
            if (!GetWindowRect((HWND)wParam, &ChildRect)) break;
            if (!GetWindowRect(hParent, &ParentRect)) break;
            if (!GetWindowRect(GetDesktopWindow(), &ScreenRect)) break;
            /*    */
            width = ChildRect.right - ChildRect.left;
            height = ChildRect.bottom - ChildRect.top;
            x = (ParentRect.left + ParentRect.right - width) / 2;
            y = (ParentRect.top + ParentRect.bottom - height) / 2;
            if (x + width > ScreenRect.right)
                x = ScreenRect.right - width;
            if (y + height > ScreenRect.bottom)
                y = ScreenRect.bottom - height;
            if (x < ScreenRect.left)
                x = ScreenRect.left;
            if (y < ScreenRect.top)
                y = ScreenRect.top;
            /*     */
            MoveWindow((HWND)wParam, x, y, width, height, FALSE);
            unhook = true;
            break;
        }
    result = CallNextHookEx(f_hHook, nCode, wParam, lParam);
    if (unhook)
        UnhookWindowsHookEx(f_hHook);
    return result;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
int MessageBoxCtr                   /* MessageBox,     */
    (
    HWND hWndParent,
    AnsiString lpText,
    AnsiString lpCaption,
    UINT uType
    )
    {
    f_hWndParent = hWndParent;
    f_hHook = SetWindowsHookEx(WH_CBT, (HOOKPROC)&CBTHookProc, NULL, GetCurrentThreadId());
    return MessageBox(hWndParent, lpText.c_str(), lpCaption.c_str(), uType);
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
