#ifndef LogfileH
#define LogfileH

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "critical.h"

/*================================================================================================*/
/*              TStringList.
 *     .
 */
class TLogfile
    {
private:
    TCritical cs;
    HANDLE hFile;
    TStringList *pLogBuffer;
    int MaxLevel;
    bool first_disk, first_screen;
public:
/*------------------------------------------------------------------------------------------------*/
    TLogfile();
    ~TLogfile();
/*------------------------------------------------------------------------------------------------*/
    void __fastcall OpenFile            /*   */
        (
        const AnsiString &FileName      /*   (  ':', '/', '\' -   EXE) */
        );
/*------------------------------------------------------------------------------------------------*/
    void __fastcall CloseFile           /*   */
        (void);
/*------------------------------------------------------------------------------------------------*/
    bool __fastcall CheckLevel          /*   */
        (
        int inLevel
        )                       { return (inLevel <= MaxLevel); }
/*------------------------------------------------------------------------------------------------*/
    void __fastcall SetLevel            /*    */
        (
        int inLevel                     /*     */
        );
/*------------------------------------------------------------------------------------------------*/
    void __fastcall Write               /*     */
        (
        const AnsiString &Message,      /*   */
        const AnsiString &TaskID,       /*  "" */
        int Level                       /*   ( = ) */
        );
/*------------------------------------------------------------------------------------------------*/
    void __fastcall Flush               /*      */
        (
        TStrings *pDisplay,             /*     */
        int MaxDisplayLines             /*  scrollback   (0 =  ) */
        );
/*------------------------------------------------------------------------------------------------*/
    static AnsiString __fastcall        /*       .exe */
        RelativeFileName
        (
        const AnsiString &FileName      /*   (  ':', '/', '\' -   EXE) */
        );
/*------------------------------------------------------------------------------------------------*/
    };
/*================================================================================================*/

#endif
