#ifndef LtrClientH
#define LtrClientH

#include "common.h"
#include "LtrCrateModule.h"

class TClient
    {
private:
    HANDLE hTermEvent;
#if PER_CLIENT_CRATE_EVENTS
    HANDLE hModuleGetEvent, hModulePutEvent;
#endif
    SOCKET socket;
    TThread *control_thread;
    TThread *recv_buf_thread;
    TThread *send_buf_thread;
    TLTRServiceCrate* crate_service;
    char peer_ip_str[32];
    char clname[256];
    TCrateModule* pmodule;
public:
    TCrate* pcrate;
    WORD crate_channel;
    WORD flags;
    TCrateModule::bufrec_t read_rec;

    TClient(SOCKET _socket, DWORD peer_ip, TLTRServiceCrate* pCrateService);
    ~TClient(void);

    bool IsOpen(void)               { return (socket != INVALID_SOCKET); }
    bool IsTerminating(void)
        { return (WSAWaitForMultipleEvents(1, &hTermEvent, FALSE, 0, FALSE) == WSA_WAIT_EVENT_0); }
    void RequestTermination(void)   { SetEvent(hTermEvent); }
    void Close(void);
#if PER_CLIENT_CRATE_EVENTS
    void SetModuleGetEvent(void)    { SetEvent(hModuleGetEvent); }
    void SetModulePutEvent(void)    { SetEvent(hModulePutEvent); }
#endif
friend
    class TControlClientThread;
friend
    class TReadClientThread;
friend
    class TWriteClientThread;
    };
//---------------------------------------------------------------------------
#define CLIENT_READ_BUF_LEN         0x20000
#define CLIENT_WRITE_BUF_LEN        0x20000

//---------------------------------------------------------------------------
class TControlClientThread : public TThread
    {
private:
    TClient *client;
    BYTE ControlBuffer[EP1K50_SIZE + 2];
    DWORD cheader[2];
    HANDLE hEventRead, hEventWrite;
    HANDLE hRawTimer;

    //DWORD RawDataBuffer[CLIENT_READ_BUF_LEN];
    DWORD* pRawDataBuffer;

    bool __fastcall ProcessStartup();
protected:
    void __fastcall Execute();
public:
    __fastcall TControlClientThread(TClient *_client, bool CreateSuspended);
    __fastcall ~TControlClientThread(void);
    int __fastcall recv(BYTE *buf, DWORD size);
    int __fastcall send(BYTE *buf, DWORD size);
    void __fastcall ack(bool ack_flag);
    };

//---------------------------------------------------------------------------
class TReadClientThread : public TThread
    {
private:
    TClient *client;
    DWORD Buf[CLIENT_READ_BUF_LEN];
protected:
    void __fastcall Execute();
public:
    __fastcall TReadClientThread(TClient *_client, bool CreateSuspended);
    //__fastcall ~TReadClientThread(void);
    };
//---------------------------------------------------------------------------
class TWriteClientThread : public TThread
    {
private:
    TClient *client;
    DWORD Buf[CLIENT_WRITE_BUF_LEN];
protected:
    void __fastcall Execute();
public:
    __fastcall TWriteClientThread(TClient *_client, bool CreateSuspended);
    //__fastcall ~TWriteClientThread(void);
    };

#endif