#ifndef LtrServiceCratesH
#define LtrServiceCratesH
#include "common.h"
#include "addrlist.h"
#include "ltrServiceClients.h"

//---------------------------------------------------------------------------
class TLTRAutoDiscovery
    {
    private:
        bool working;
        SOCKET udp_socket;
        UCHAR signature[16];
        UCHAR recv_buf[16];
        struct bufctl
            {
            unsigned int failcount;
            DWORD flags;
            WSABUF buf;
            WSAOVERLAPPED overlap;
            }
            request, reply;
        struct timerctl
            {
            HANDLE handle;
            LARGE_INTEGER interval;
            }
            send_timer;
        sockaddr_in bcast_addr;
        sockaddr peer_addr;
        int peer_addr_size;

        void do_Send();
        void do_Receive();
    public:
        TLTRAutoDiscovery();
        ~TLTRAutoDiscovery();
        void Start();
        void Stop();
        bool Worker(DWORD *pPeerIP);
    };
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TLTRServiceCrate : public TThread
{
 private:
    TLTRAutoDiscovery AutoDiscovery;

    void __fastcall ScanUSBCrates(void);
    void __fastcall StopServiceForDeadCrates(void);
    void __fastcall ConnectUSBCrate(DWORD DevInst, const char* szPath = NULL);
    void __fastcall DisconnectUSBCrate(DWORD DevInst);
    void __fastcall ConnectCrateByIP(DWORD dwIP);
    void __fastcall DisconnectCrateByIP(DWORD dwIP);
    void __fastcall ConnectAllIPCratesByType(int IPListType);
    void __fastcall DisconnectAllIPCratesByType(int IPListType);
 protected:
    void __fastcall Execute();
    TLTRServiceClient* ltrserviceclient;
    MessageQueue<MsgDisplay>& refMQ_Display;
    MessageQueue<MsgControl> MQ_Control;
 public:
    HANDLE init_complete;
    bool init_ok;
    void __fastcall SuspendCrates();
    void __fastcall ResumeCrates();
    __fastcall TLTRServiceCrate(bool CreateSuspended, MessageQueue<MsgDisplay>& mqDisplay);
    __fastcall ~TLTRServiceCrate(void);
    void inline PostControlMessage(const MsgControl& msg)
        { MQ_Control.put(msg); }
    void inline PostDisplayMessage(const MsgDisplay& msg)
        { refMQ_Display.put(msg); }
};
//---------------------------------------------------------------------------
#endif
