//$$---- Form HDR ----
//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>
#include <ToolWin.hpp>
#include <DBGrids.hpp>
#include <DBCtrls.hpp>
#include <DB.hpp>
#include <DBClient.hpp>
#include <Mask.hpp>
#include <DBTables.hpp>
//---------------------------------------------------------------------------
#include "LtrCrate.h"
#include "LtrServiceCrates.h"
#include "LtrClient.h"
#include "MessageQueue.h"

// Custom windows message to restart server
#define WM_APP_RESTART  (WM_APP + 0)

extern bool g_bNoTrayIcon;

class TFormMAIN;
//---------------------------------------------------------------------------
class TUpdateInfoThread : public TThread
{
 private:
    TFormMAIN* Form;
    struct
        {
        bool reset;
        char path[1024];
        int slot;
        int tick_count;
        __int64 count_recv;
        __int64 count_send;
        }
        Stats;

    AnsiString SC_CRATE_TITLE_FORMAT;
    AnsiString SC_empty;
    AnsiString SC_Initialization;
    AnsiString SC_unknown_interface;
    AnsiString SC_Unknown_Crate;
    AnsiString SC_boot_loader;
    AnsiString SC_state_error;
    AnsiString SC_state_ok;
    AnsiString SC_Bad_Module_Name;

    AnsiString SC_Crate_statistics_for;
    AnsiString SC_Crate_serial_number;
    AnsiString SC_Interface;
    AnsiString SC_Connected;
    AnsiString SC_HwRevision;
    AnsiString SC_Total_sent_words;
    AnsiString SC_Total_recv_words;
    AnsiString SC_Data_input_speed;
    AnsiString SC_Data_output_speed;
    AnsiString SC_words_per_second;
    AnsiString SC_Start_marks_received;
    AnsiString SC_Second_marks_received;
    AnsiString SC_Statistics_for_slot;
    AnsiString SC_Status;
    AnsiString SC_No_module;
    AnsiString SC_Identifying_module;
    AnsiString SC_Contains_module;
    AnsiString SC_Num_sent_words;
    AnsiString SC_Num_recv_words;
    AnsiString SC_Server_buffer_util;
    AnsiString SC_Connected_clients;
    AnsiString SC_Hardware_FIFO_state;

 protected:
    void __fastcall Execute(void);
    void __fastcall UpdateCrateList(void);
    void __fastcall UpdateIPList(void);
    void __fastcall UpdateStatistics(void);
    void __fastcall UpdateLog(void);
    void __fastcall UpdateVars(void);
 public:
    __fastcall TUpdateInfoThread(TFormMAIN *ParentForm);
    __fastcall ~TUpdateInfoThread(void);
};



//----------------------------------------------------------------
class TFormMAIN : public TForm
{
__published:    // IDE-managed Components
    TPageControl *PageControl1;
    TTabSheet *TabSheetCrateList;
    TTabSheet *TabSheetIPCrates;
    TPopupMenu *GridPopupMenu;
    TTabSheet *TabSheetLog;
    TRichEdit *log_list;
    TStatusBar *StatusBar1;
    TGroupBox *GroupBoxStat;
    TMemo *Statistic;
    TGroupBox *GroupBoxTree;
    TTreeView *CrateTree;
    TSplitter *Splitter2;
    TMenuItem *PopupDeleteCrateIP;
    TMenuItem *PopupAddCrateIP;
    TMenuItem *PopupConnectCrate;
    TMenuItem *PopupDisconnectCrate;
    TMenuItem *PopupConnectAllIP;
    TMenuItem *PopupDisconnectAllIP;
    TMenuItem *PopupAutoConnectIPToggle;
    TMainMenu *MainMenu1;
    TMenuItem *MenuFile;
    TMenuItem *MenuFileRestart;
    TMenuItem *MenuFileExit;
    TMenuItem *MenuSettings;
    TMenuItem *MenuSettingsAD_enable;
    TMenuItem *MenuSettingsAD_autoconnect;
    TMenuItem *MenuSettingsHighPriority;
    TMenuItem *MenuSettingsStartMinimized;
    TMenuItem *MenuSettingsMinimizeToTray;
    TMenuItem *MenuSettingsLang;
    TMenuItem *MenuSettingsLang_auto;
    TMenuItem *MenuSettingsLang_en;
    TMenuItem *MenuSettingsLang_ru;
    TMenuItem *MenuLogLevel;
    TMenuItem *MenuLogLevel_0;
    TMenuItem *MenuLogLevel_1;
    TMenuItem *MenuLogLevel_2;
    TMenuItem *MenuLogLevel_3;
    TMenuItem *MenuLogLevel_4;
    TMenuItem *MenuLogLevel_5;
    TMenuItem *MenuLogLevel_6;
    TMenuItem *MenuLogLevel_7;
    TStringGrid *StringGridIPCrates;
    TPopupMenu *TrayPopupMenu;
    TMenuItem *TrayPopupRestart;
    TMenuItem *TrayPopupHighPriority;
    TMenuItem *TrayPopupShutdown;
    TMenuItem *TrayPopupRestore;
    TPopupMenu *LogPopupMenu;
    TMenuItem *LogPopupClear;
    TMenuItem *PopupEditCrateIP;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall TrayIcon1Click(TObject *Sender);
    void __fastcall TrayIcon1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall GridContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled);
    void __fastcall PopupAddCrateIPClick(TObject *Sender);
    void __fastcall PopupEditCrateIPClick(TObject *Sender);
    void __fastcall PopupDeleteCrateIPClick(TObject *Sender);
    void __fastcall PopupConnectCrateClick(TObject *Sender);
    void __fastcall PopupDisconnectCrateClick(TObject *Sender);
    void __fastcall PopupConnectAllIPClick(TObject *Sender);
    void __fastcall PopupDisconnectAllIPClick(TObject *Sender);
    void __fastcall StringGridIPCratesDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall StringGridIPCratesDblClick(TObject *Sender);
    void __fastcall PopupAutoConnectIPToggleClick(TObject *Sender);
    void __fastcall PageControl1Resize(TObject *Sender);
    void __fastcall MenuFileRestartClick(TObject *Sender);
    void __fastcall MenuFileExitClick(TObject *Sender);
    void __fastcall MenuLogLevelClick(TObject *Sender);
    void __fastcall MenuSettingsLangClick(TObject *Sender);
    void __fastcall MenuSettingsHighPriorityClick(TObject *Sender);
    void __fastcall MenuSettingsStartMinimizedClick(TObject *Sender);
    void __fastcall MenuSettingsMinimizeToTrayClick(TObject *Sender);
    void __fastcall MenuSettingsAD_autoconnectClick(TObject *Sender);
    void __fastcall MenuSettingsAD_enableClick(TObject *Sender);
    void __fastcall StringGridIPCratesMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
    void __fastcall AppMinimize(TObject *Sender);
    void __fastcall AppRestore(TObject *Sender);
    void __fastcall LogPopupClearClick(TObject *Sender);
    void __fastcall StringGridIPCratesKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
private:    // User declarations
    TStringList* CrateTreeTags;
    TUpdateInfoThread * UpdateInformationThread;
    struct
        {
        AnsiString Connect;
        AnsiString Disconnect;
        AnsiString AutoConnect;
        AnsiString Delete;
        AnsiString Edit;
        }
        MenuCaption;
    LANGID CurrentLangID;
    TMenuItem *LogLevelMenuItemList[8];
    TMenuItem *LangMenuItemList[3];
    TTrayIcon* TrayIcon;
    WORD IPGridColWidth[8]; //      1000px
    MessageQueue<MsgDisplay> MQ_Display;
    HDEVNOTIFY hDevNotify;

    //  ( = error,  =  ,  = ok)
    enum en_IconID { icoUndef = -1, icoNoCrates, icoCrateOk, icoCrateError };
    struct TMyIconSet
        {
        HICON AppIcon[3];
        HICON TrayIcon[3];
        enum en_IconID CurrentId;
        }
        IconSet;

    void __fastcall SetIcon(en_IconID id);
    int __fastcall GetPopupNode(TAddrListNode *pNode);
    bool __fastcall ValidCell(int X, int Y);
    void __fastcall Restart();
    LANGID __fastcall GetLanguage() { return CurrentLangID; }
    void __fastcall SetLanguage(LANGID langid);

public:     // User declarations
    bool init_ok;
    TLTRServiceCrate* ltrservicecrate;
    TFormatSettings LocaleFormatSettings;

    __fastcall TFormMAIN(TComponent* Owner);
    __fastcall ~TFormMAIN();
     virtual void __fastcall Dispatch(void *_msg);

     friend TUpdateInfoThread;
};

//---------------------------------------------------------------------------
extern PACKAGE TFormMAIN *FormMAIN;
//---------------------------------------------------------------------------
#endif
